/*
  iconmenu.cpp
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include <qpainter.h>
#include <qimage.h>
#include <qbitmap.h>
#include <qcursor.h>

#include "qgmap.h"
#include "mainwindow.h"
#include "iconmenu.h"
#include "inputdialog.h"

IconMenu::IconMenu(LayeredBase *parent, const char *name) :
	LayeredWidget(parent, name)
{
	icon.load(MENUIMG_FILE);
	setGeometry(10,10, icon.width(), icon.height());

	popup_menu.insertItem("Map Path", this, SLOT(menu_activated(int)));
}

bool IconMenu::paintEvent(QPaintEvent *e UNUSED, QPixmap &scr)
{
	QPainter p(&scr);
	p.drawPixmap(10, 10, icon);
	return true;
}

bool IconMenu::mousePressEvent( QMouseEvent *e )
{
	if(e->button() == LeftButton)
		popup_menu.popup(QCursor::pos());

	return false;
}

void IconMenu::menu_activated(int id UNUSED)
{
	InputDialog dlg(parentWidget(), "Map Path", TRUE);

	dlg.setText(((MainWindow *)parentWidget())->getConfig("MapPath", DEFAULT_MAP_PATH));

	int ret = dlg.exec();
	if(ret == QDialog::Accepted){
		((MainWindow *)parentWidget())->setConfig("MapPath", dlg.getText());
	}
}
