/*
  iconmenu.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __ICONMENU_H__
#define __ICONMENU_H__

#include <qwidget.h>
#include <qpixmap.h>
#include <qpopupmenu.h>

#include "layeredwidget.h"

class IconMenu : public LayeredWidget
{
	Q_OBJECT
  public:
	IconMenu(LayeredBase *parent=0, const char *name=0);

  private:
	bool paintEvent(QPaintEvent *e, QPixmap &scr);
	bool mousePressEvent( QMouseEvent *e );

	QPixmap icon;
	QPopupMenu popup_menu;

  public slots:
	void menu_activated(int id);
};


#endif // __ICONMENU_H__
